import { get } from 'https';
import { parseContributions, parseGitHubStats, } from './transformers';
const fetchStats = (username, options) => new Promise((resolve, reject) => {
    get(`https://github.com/users/${username}/contributions`, (response) => {
        let body = '';
        response.setEncoding('utf8');
        response.on('data', (chunk) => {
            body += chunk;
        });
        response.on('end', () => {
            if (response.statusCode === 404) {
                if (options === null || options === void 0 ? void 0 : options.onFailure)
                    return options.onFailure(response);
                return reject(response);
            }
            const contributions = parseContributions(body);
            const gitHubStats = parseGitHubStats(contributions);
            if (options === null || options === void 0 ? void 0 : options.onSuccess)
                return options.onSuccess(gitHubStats);
            return resolve(gitHubStats);
        });
    });
});
export { fetchStats };
